package jp.haw.grain.transform.transformer;

import jp.haw.grain.transform.GudBuilder;

import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

public class Label2Label extends AbstractTransformer {

	protected GudBuilder builder;
	protected Element current;

	public Label2Label(GudBuilder builder) {
		this.builder = builder;
	}

	public Element getCurrentElement() {
		return null;
	}

	protected boolean isTarget(Node node) {
		if (node.getNodeType() != Node.ELEMENT_NODE)
			return false;

		Element e = (Element)node;
		if (e.getNamespaceURI() != GudBuilder.XFORMS_NS)
			return false;

		return e.getLocalName().equals("label");
	}

	public DocumentFragment transform() {
		Document dom = builder.getGudDoc();
		DocumentFragment df = dom.createDocumentFragment();
		Element xforms_label = (Element)node;
		Element gud_label = dom.createElementNS(GudBuilder.GUD_NS, "label");

		if(xforms_label.getTextContent() != null) {
			Text gud_text = dom.createTextNode(xforms_label.getTextContent());
			gud_label.appendChild(gud_text);
			df.appendChild(gud_label);
		}

		//eLXgm[hXLbvXgɓo^
		registSkipList(xforms_label.getChildNodes());
		
		this.current = null;

		return df;

	}

	protected void registSkipList(NodeList list) {
		for (int i = 0; i < list.getLength(); i++) {
			Node skipNode = list.item(i);
			builder.addSkipNode(skipNode);
		}

	}

}
