package jp.haw.grain.transform.transformer;

import jp.haw.grain.transform.GudBuilder;
import jp.haw.grain.transform.util.Util;
import jp.haw.grain.xpath.compiler.ParseException;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.Element;
import org.w3c.dom.Node;


/**
 * @author nakajo
 */
public class Submit2Button extends AbstractTransformer {

	protected GudBuilder builder;
	protected Element current;

	public Submit2Button(GudBuilder builder) {
		this.builder = builder;
	}
	
	
	public Element getCurrentElement() {
		return this.current;
	}

	protected boolean isTarget(Node node) {
		if(node.getNodeType() != Node.ELEMENT_NODE) return false;
		
		Element e = (Element)node;
		if(e.getNamespaceURI() != GudBuilder.XFORMS_NS) return false;
		
		return e.getLocalName().equals("submit");
	}

	/* ( Javadoc)
	 * @see jp.haw.grain.transform.Transformer#transform()
	 */
	public DocumentFragment transform() {
		Document dom = builder.getGudDoc();
		DocumentFragment df = dom.createDocumentFragment();
		
		Element xforms_submit = (Element)node;
		Element gud_button = dom.createElementNS(GudBuilder.GUD_NS, "button");
		Element gud_send = dom.createElementNS(GudBuilder.GUD_NS, "send");
		gud_button.appendChild(gud_send);
		
		//buildereventpNSo^
		builder.addNamespace("ev", GudBuilder.EVENT_NS);
		
		Attr event = dom.createAttributeNS(GudBuilder.EVENT_NS, "ev:event");
		event.setNodeValue("DOMActivate");
		gud_send.setAttributeNodeNS(event);
		gud_send.setAttribute("submission", xforms_submit.getAttribute("submission"));
		
		//Rs[
		//refoCgR[hɓWJ
		Util.copyAttributes(xforms_submit, gud_button);
		try {
			Util.compileRef(gud_button);
		} catch (ParseException e) {
			throw new RuntimeException(e);
		}
		
		df.appendChild(gud_button);
		
		this.current = gud_button;
		return df;
	}

}
